#include "my_gfx.h"
#include <math.h>

/* Wlasciwosci lupy */
#define RADIUS  50     // Promien lupy
#define MAGNIFY 27     // Wspolczynnik powiekszenia < RADIUS

/* Zmienne globalne */
int  lens_table[RADIUS * RADIUS * 4];
BYTE screen_buf[RADIUS * RADIUS * 4];

void Create_lens_table(void)
{
  int    a, b, x, y;
  double s, z;

  s = RADIUS*RADIUS - MAGNIFY*MAGNIFY;
  for(y = -RADIUS; y < RADIUS; y++)
    for(x = -RADIUS; x < RADIUS; x++) {
      if( ( x*x + y*y ) >= s) {
        a = x; b = y;
      }
      else {
        z = sqrt( (double) (RADIUS*RADIUS - x*x - y*y) );
        a = (int) ( (double) ( (double) ( (x*MAGNIFY) / z ) ) + 0.5 );
        b = (int) ( (double) ( (double) ( (y*MAGNIFY) / z ) ) + 0.5 );
      }
      lens_table[ (y + RADIUS) * RADIUS * 2 + (x + RADIUS) ] =
        ( b + RADIUS ) * 320 + ( a + RADIUS );
    }
}

void Do_lens(bitmap *b, int x, int y)
{
  int  i, j, k;
  BYTE *temp, *temp2;
  int  *temp3;

  temp  = virtual_screen + x + ( y << 8 ) + ( y << 6 );
  temp2 = b->data + x + ( y << 8 ) + ( y << 6 );
  temp3 = lens_table;
  k = RADIUS << 1;
  for(j = 0; j < k; j++, temp += (320 - k) )
    for(i = 0; i < k; i++, temp++, temp3++ ) {
      *temp = *(temp2 + *temp3 );
    }
}
