#include <strings.h>
#include "my_gfx.h"

/* Zmienne globalne */
int  Height[2][64000]; // Mapy wysokosci (zrodlo, cel)
BYTE num_map = 0;      // Numer mapy aktualnie wybranej jako zrodlo
BYTE density = 4;      // Gestosc wody (1..31)
bitmap temp2;

extern int SinTable[256];
extern int CosTable[256];
BYTE w_katx =0, w_katy =0;

/* Deklaracje funkcji */
void Do_water(bitmap *b);
void Do_surfer();
void Do_Sign(bitmap *src, int posx, int posy);

void Do_water(bitmap *b)
{
  int x, y, index_x, index_y;
  int offs;
  int dx, dy, col;
  int *t1 = Height[num_map^1];
  int *t2 = Height[num_map];

  // Obliczenie nowej mapy wysokosci
  offs = 321;
  for(y = 1; y < 199; y++, offs += 2)
    for(x = 1; x < 319; x++, offs++) {
    //  t1[offs] = ( ( t2[offs-1] + t2[offs+1] +
    //             t2[offs-320] + t2[offs+320] ) >> 1 ) - t1[offs];
      t1[offs] = ( ( t2[offs-1] + t2[offs+1] +
                     t2[offs-320] + t2[offs+320] +
                     t2[offs-321] + t2[offs-319] +
                     t2[offs+321] + t2[offs+319] ) >> 2 ) - t1[offs];
      t1[offs] -= ( t1[offs] >> density );
    }

  // Obliczenie efektu i wyswietlenie na ekran
  memset(virtual_screen, 0, 320); // wyczysc gorna linie ekranu
  offs = 321;
  for(y = 1; y < 199; y++, offs +=2) {
    memset(virtual_screen + offs - 2, 0, 2); // wyczysc boki ekranu
    for(x = 1; x < 319; x++, offs++) {
      dx = t1[offs] - t1[offs+1];
      dy = t1[offs] - t1[offs+320];

      col = 128 - dx;

      dx >>=3;
      dy >>=3;

      index_x = x + dx;
      index_y = y + dy;

      col = (b->data[index_x + (index_y << 8) + (index_y << 6)] * col ) >> 7;

      col = ( col < 0 ) ? 0 : ( col > 255 ) ? 255 : col;

      virtual_screen[offs] = col;
    }
  }
  memset(virtual_screen + 63680, 0, 320); // wyczysc jeszcze ostatnia linie
  num_map ^= 1;
}

void Do_surfer()
{
  int *t1 = Height[num_map^1];
  int x, y;
  int tempy;

  x = ( CosTable[w_katx] >> 1 ) + 160;
  y = ( SinTable[w_katy] >> 2 ) + 100;

  tempy = (y << 8) + (y << 6);
  t1[x + 1 + tempy]           = 1000;
  t1[x - 1 + tempy]           = 1000;
  t1[x + tempy + 320]         = 1000;
  t1[x + tempy - 320]         = 1000;
  t1[x + tempy]               = 2000;
}

void Do_Sign(bitmap *src, int posx, int posy)
{
  int x, y;
  int offs;
  int *t1 = Height[num_map^1];
  BYTE *haha;

  offs = posx + (posy << 8) + (posy << 6);
  haha = src->data;
  for(y = 0; y < src->height; y++, offs += (320 - src->width) )
    for(x = 0; x < src->width; x++, offs++, haha++)
      if( *haha ) t1[offs] = 2000;

}
