#include "my_gfx.h"

extern int SinTable[256];
extern int CosTable[256];

void Do_rotozoom(bitmap *b, BYTE *dst, int scale, BYTE angle)
{
  int  x, y;
  int  s, c;
  int  u, v;
  int  tu, tv;
  int  start_u, start_v;
  BYTE *temp;

  /* Wzory na obrot :  x = x*cos - y*sin; y = x*sin + y*cos;  */

  /* Inicjalizacja zmiennych ( 16.16 fixed point ) */
  s = scale * SinTable[angle];
  c = scale * CosTable[angle];

  start_u = ( (-160) * c ) + ( 100 * s ) + (160 << 16);
  start_v = ( (-160) * s ) - ( 100 * c ) + (100 << 16);
  temp = dst;
  for(y = -100; y < 100; y++) {
    u = start_u;
    v = start_v;
    for(x = -160; x < 160; x++, temp++) {
      tu = u >> 16; tv = v >> 16;

      if( ( tu > 0 ) && ( tu < 320 ) && ( tv > 0 ) && ( tv < 200 ) )
        *temp = b->data[ ( tv << 8 ) + ( tv << 6 ) + tu ];
      else *temp = 0;

      u += c;
      v += s;
    }
    start_v += c;
    start_u -= s;
  }
}

void Do_signzoom(bitmap *b, int scale)
{
  int  x, y;
  int  s, c;
  int  u, v;
  int  tu, tv, tc;
  int  start_u, start_v;
  BYTE *temp;

  /* Inicjalizacja zmiennych */
  s = 0;          // sin(0) = 0
  c = scale << 8; // cos(0) = 1 ( 256 w fixed point )

  start_u = ( (-160) * c ) + (64 << 16);
  start_v = ( (-100) * c ) + (64 << 16);
  temp = virtual_screen;
  for(y = -100; y < 100; y++) {
    u = start_u;
    v = start_v;
    for(x = -160; x < 160; x++, temp++) {
      tu = u >> 16; tv = v >> 16;

      if( ( tu > 0 ) && ( tu < 128 ) && ( tv > 0 ) && ( tv < 128 ) ) {
        tc = b->data[ (tv << 7) + tu ];
        if( tc ) *temp = 255;
      }

      u += c;
      v += s;
    }
    start_v += c;
    start_u -= s;
  }
}
